> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Query campaigns based on specified criteria.

POST https://prod-api.raisedonors.com/api/Campaign/query
Content-Type: application/json

To discover available fields and operators for campaign queries:
Call `/api/query/options/Campaign` to retrieve parameters, operators, and result fields.Build one or more groups of conditions using those parameters.POST the resulting RaiseDonors.Api.Models.Query.QueryRequestModel to this endpoint.
For numeric fields using the `Between` operator, provide the lower bound
in `value` and the upper bound in `secondaryValue`.
When `includeDetails=true`, the response includes all related entities (Segments, Pages, PageStatistics)
similar to the GET by ID endpoint. This may impact performance for large result sets.

Reference: https://virtuous.ferndocs.com/reference/raise/campaign/querycampaigns

## Authentication

- `Authorization` header (required) — JWT Authorization header using the Bearer scheme. Example: "Authorization: Bearer \{token}"

## Request

### Body (application/json)

This endpoint expects a Campaign_querycampaigns_Request.

- `Campaign_querycampaigns_Request`
  - QueryRequestModel: QueryRequestModel
  - ParsedQueryResponseModel: ParsedQueryResponseModel

## Response

### 200

OK

- `items` (list of CampaignModel, optional)
- `total` (integer, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `Campaign_QueryCampaignsRequestBadRequestError`
  - ProblemDetails: ProblemDetails
  - HttpValidationProblemDetails: HttpValidationProblemDetails

## Types

### QueryRequestModel

Request body for advanced query endpoints such as donor and campaign queries.

- `filter` (string, optional, nullable)
- `skip` (integer, optional)
- `take` (integer, optional)
- `sortBy` (enum, optional, nullable) — Field to sort by (case-insensitive). Valid options: createdate, createddatetime, email, firstname, gifts, giftsum, id, lastname, modifieddatetimeutc, name, phone
  - Allowed values: `createdate`, `createddatetime`, `email`, `firstname`, `gifts`, `giftsum`, `id`, `lastname`, `modifieddatetimeutc`, `name`, `phone`
- `descending` (boolean, optional)
- `includeDetails` (boolean, optional)
- `queryType` (enum, optional) — The logical type of query being executed.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`
- `groups` (list of QueryGroupModel, optional, nullable) — The groups of conditions that make up the query.
- `selectedColumns` (list of string, optional, nullable) — The list of result columns to return for each item.
- `empty` (boolean, optional) — Indicates whether the query has any conditions defined.

### ParsedQueryResponseModel

Represents a parsedquery response model.

- `descending` (boolean, optional)
- `empty` (boolean, optional) — Indicates whether the query has any conditions defined.
- `filter` (string, optional, nullable)
- `groups` (list of QueryGroupModel, optional, nullable) — The groups of conditions that make up the query.
- `includeDetails` (boolean, optional)
- `queryType` (enum, optional) — The logical type of query being executed.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`
- `selectedColumns` (list of string, optional, nullable) — The list of result columns to return for each item.
- `skip` (integer, optional)
- `sortBy` (enum, optional, nullable) — Field to sort by (case-insensitive). Valid options: createdate, createddatetime, email, firstname, gifts, giftsum, id, lastname, modifieddatetimeutc, name, phone
  - Allowed values: `createdate`, `createddatetime`, `email`, `firstname`, `gifts`, `giftsum`, `id`, `lastname`, `modifieddatetimeutc`, `name`, `phone`
- `take` (integer, optional)

### CampaignModel

Represents the detailed view of a campaign returned by create, update, and single-campaign retrieval endpoints.

- `id` (long, optional) — Gets or sets the identifier.
- `name` (string, optional, nullable) — Gets or sets the name.
- `description` (string, optional, nullable) — Gets or sets the description.
- `startDate` (string, optional, nullable) — Gets or sets the start date.
- `endDate` (string, optional, nullable) — Gets or sets the end date.
- `duration` (string, optional, nullable) — Gets or sets the duration.
- `canSync` (boolean, optional) — Gets or sets the can sync.
- `crmKey` (string, optional, nullable) — Gets or sets the crmkey.
- `crmKeyUrls` (map from string to CrmUrlInfo, optional, nullable) — CRM URLs for this campaign grouped by integration type.
- `applySegmentToRecurringGifts` (boolean, optional) — Gets or sets the apply segment to recurring gifts.
- `givingGoal` (double, optional) — The giving goal for the campaign in the organization base currency.
- `givingGoalFormatted` (string, optional, nullable) — The giving goal formatted for display in the organization currency (for example "$10,000.00").
- `hasGivingGoal` (boolean, optional) — Gets or sets the has giving goal.
- `raisedAmount` (string, optional, nullable) — Gets or sets the raised amount.
- `raisedPercentage` (double, optional) — Percentage of the giving goal that has been raised (0–100).
- `totalGiftGoal` (integer, optional) — Gets or sets the total gift goal.
- `hasTotalGiftGoal` (boolean, optional) — Gets or sets the has total gift goal.
- `totalGifts` (integer, optional) — Gets or sets the total gifts.
- `totalGiftsPercentage` (double, optional) — Percentage of the gift count goal that has been reached (0–100).
- `totalDonors` (integer, optional) — Gets or sets the total donors.
- `averageGiftGoal` (double, optional) — The target average gift amount in the organization base currency.
- `averageGiftGoalFormatted` (string, optional, nullable) — The target average gift amount formatted for display (for example "$100.00").
- `averageGiftAmount` (string, optional, nullable) — The actual average gift amount formatted for display.
- `hasAverageGiftGoal` (boolean, optional) — Gets or sets the has average gift goal.
- `totalVisitors` (integer, optional) — Gets or sets the total visitors.
- `conversionRate` (string, optional, nullable) — The conversion rate for the campaign formatted as a percentage string (for example "12.3%").
- `createdDateTime` (string, optional, nullable) — Gets or sets the created date time.
- `modifiedDateTime` (string, optional, nullable) — Gets or sets the modified date time.

### ProblemDetails

- `type` (string, optional, nullable)
- `title` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `detail` (string, optional, nullable)
- `instance` (string, optional, nullable)

### HttpValidationProblemDetails

- `detail` (string, optional, nullable)
- `errors` (map from string to list of string, optional, nullable)
- `instance` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `title` (string, optional, nullable)
- `type` (string, optional, nullable)

### QueryGroupModel

- `conditions` (list of QueryConditionModel, optional, nullable) — Gets or sets the conditions.
- `conjunct` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`

### CrmUrlInfo

- `crmKey` (string, optional, nullable)
- `url` (string, optional, nullable)

### QueryConditionModel

- `parameter` (string, optional, nullable) — Gets or sets the parameter.
- `operator` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `13`, `14`, `15`, `16`, `17`, `18`, `19`, `20`, `21`, `22`, `23`, `24`, `25`, `26`, `27`, `28`, `29`
- `value` (string, optional, nullable) — Gets or sets the value.
- `secondaryValue` (string, optional, nullable) — Gets or sets the secondary value.
- `values` (list of string, optional, nullable) — Gets or sets the values.
- `conjunct` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "items": [
    {
      "id": 1024,
      "name": "Annual Fundraiser 2024",
      "description": "A campaign to raise funds for community development projects throughout 2024.",
      "startDate": "2024-01-01T00:00:00Z",
      "endDate": "2024-12-31T23:59:59Z",
      "duration": "365 days",
      "canSync": true,
      "crmKey": "AF2024-CRM",
      "crmKeyUrls": {},
      "applySegmentToRecurringGifts": true,
      "givingGoal": 50000,
      "givingGoalFormatted": "$50,000.00",
      "hasGivingGoal": true,
      "raisedAmount": "$35,750.00",
      "raisedPercentage": 71.5,
      "totalGiftGoal": 500,
      "hasTotalGiftGoal": true,
      "totalGifts": 375,
      "totalGiftsPercentage": 75,
      "totalDonors": 320,
      "averageGiftGoal": 100,
      "averageGiftGoalFormatted": "$100.00",
      "averageGiftAmount": "$95.33",
      "hasAverageGiftGoal": true,
      "totalVisitors": 1200,
      "conversionRate": "26.7%",
      "createdDateTime": "2023-11-15T09:30:00Z",
      "modifiedDateTime": "2024-04-10T16:45:00Z"
    }
  ],
  "total": 1
}
```

**SDK Code**

```python
import requests

url = "https://prod-api.raisedonors.com/api/Campaign/query"

payload = {}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://prod-api.raisedonors.com/api/Campaign/query';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://prod-api.raisedonors.com/api/Campaign/query"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://prod-api.raisedonors.com/api/Campaign/query")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://prod-api.raisedonors.com/api/Campaign/query")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://prod-api.raisedonors.com/api/Campaign/query', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://prod-api.raisedonors.com/api/Campaign/query");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://prod-api.raisedonors.com/api/Campaign/query")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```